local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local CurrentTimestamp = 0
local event, sourceGUID, destGUID, destFlags, spellId, spellName, amount, destName, sourceName
local AoETargets = {}
local myself, pet
local target_is_outsider = false
local source_is_outsider = false
local dreadstalkers = {}
local wildimps = {}
local darkglare = {}
local doomguard = {}
local infernal = {}
local service = {}

x.LastCastTime = 0
x.LastCastSpell = 0

a.dreadstalker_no_de = function()
	local i = 0
	local ts = GetTime()
	foreach(dreadstalkers, function(k, v)
		if ts - v.summoned >= 12 then
			dreadstalkers[k] = nil
		elseif not v.de then
			i = i + 1
		end
	end)
	if s.Casting(104316--[[Call Dreeadstalkers]], "player") then
		i = i + 2
	end
	return i
end

a.dreadstalker_count = function()
	local i = 0
	local ts = GetTime()
	foreach(dreadstalkers, function(k, v)
		if ts - v.summoned >= 12 then
			dreadstalkers[k] = nil
		else
			i = i + 1
		end
	end)
	if s.Casting(104316--[[Call Dreeadstalkers]], "player") then
		i = i + 2
	end
	return i
end

a.dreadstalker_remaining_duration = function()
	local i = 20
	local ts = GetTime()
	foreach(dreadstalkers, function(k, v)
		if ts - v.summoned >= 12 then
			dreadstalkers[k] = nil
		else
			i = math.min(i, 12 - ts + v.summoned)
		end
	end)
	if i <= 12 then
		return i
	else
		return 0
	end
end

a.wild_imp_no_de = function()
	local i = 0
	local ts = GetTime()
	foreach(wildimps, function(k, v)
		if ts - v.summoned >= 12 then
			wildimps[k] = nil
		elseif not v.de then
			i = i + 1
		end
	end)
	if s.Casting(104316--[[Call Dreeadstalkers]], "player") and s.HasTalent(196272--[[Improved Dreadstalkers]]) then
		i = i + 2
	end
	return i
end

a.wild_imp_count = function()
	local i = 0
	local ts = GetTime()
	foreach(wildimps, function(k, v)
		if ts - v.summoned >= 12 then
			wildimps[k] = nil
		else
			i = i + 1
		end
	end)
	if s.Casting(104316--[[Call Dreeadstalkers]], "player") and s.HasTalent(196272--[[Improved Dreadstalkers]]) then
		i = i + 2
	end
	return i
end

a.wild_imp_remaining_duration = function()
	local i = 20
	local ts = GetTime()
	foreach(wildimps, function(k, v)
		if ts - v.summoned >= 12 then
			wildimps[k] = nil
		else
			i = math.min(i, 12 - ts + v.summoned)
		end
	end)
	if i <= 12 then
		return i
	else
		return 0
	end
end

a.doomguard_no_de = function()
	local i = 0
	local ts = GetTime()
	foreach(doomguard, function(k, v)
		if ts - v.summoned >= 12 then
			doomguard[k] = nil
		elseif not v.de then
			i = i + 1
		end
	end)
	return i
end

a.infernal_no_de = function()
	local i = 0
	local ts = GetTime()
	foreach(infernal, function(k, v)
		if ts - v.summoned >= 12 then
			infernal[k] = nil
		elseif not v.de then
			i = i + 1
		end
	end)
	return i
end

a.service_no_de = function()
	local i = 0
	local ts = GetTime()
	foreach(service, function(k, v)
		if ts - v.summoned >= 12 then
			service[k] = nil
		elseif not v.de then
			i = i + 1
		end
	end)
	return i
end

a.darkglare_no_de = function()
	local i = 0
	local ts = GetTime()
	foreach(darkglare, function(k, v)
		if ts - v.summoned >= 12 then
			darkglare[k] = nil
		elseif not v.de then
			i = i + 1
		end
	end)
	return i
end

a.getPetCount = function()
	local i = 1
	local ts = GetTime()
	foreach(dreadstalkers, function(k, v)
		if ts - v.summoned >= 12 then
			dreadstalkers[k] = nil
		else
			i = i + 1
		end
	end)
	foreach(wildimps, function(k, v)
		if ts - v.summoned >= 12 then
			wildimps[k] = nil
		else
			i = i + 1
		end
	end)
	foreach(doomguard, function(k, v)
		if ts - v.summoned >= 12 then
			doomguard[k] = nil
		else
			i = i + 1
		end
	end)
	foreach(infernal, function(k, v)
		if ts - v.summoned >= 12 then
			infernal[k] = nil
		else
			i = i + 1
		end
	end)
	foreach(service, function(k, v)
		if ts - v.summoned >= 12 then
			service[k] = nil
		else
			i = i + 1
		end
	end)
	foreach(darkglare, function(k, v)
		if ts - v.summoned >= 12 then
			darkglare[k] = nil
		else
			i = i + 1
		end
	end)
	if s.Casting(104316--[[Call Dreeadstalkers]], "player") then
		if s.HasTalent(196272--[[Improved Dreadstalkers]]) then
			i = i + 4
		else
			i = i + 2
		end
	end
	if s.Casting(105174--[[Hand of Gul'dan]], "player") then
		i = i + x.SoulShards
	end
	return i
end

a.COMBAT_LOG_EVENT_UNFILTERED = function (event, ...)
	CurrentTimestamp, event, _, sourceGUID, sourceName, sourceFlags, _, destGUID, destName, destFlags, _, spellId, spellName = ...
	local ts = GetTime()
	myself = UnitGUID("player")
	pet = UnitGUID("pet")
	target_is_outsider = bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
	source_is_outsider = bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) > 0
	
	if (event=="SPELL_SUMMON" and destName=="Dreadstalker" and sourceGUID == myself) then
		dreadstalkers[destGUID] = {}
		dreadstalkers[destGUID].summoned = ts
		dreadstalkers[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Wild Imp" and sourceGUID == myself) then
		wildimps[destGUID] = {}
		wildimps[destGUID].summoned = ts
		wildimps[destGUID].de = false
		wildimps[destGUID].casts = 0
	end
	if (event=="SPELL_SUMMON" and destName=="Doomguard" and sourceGUID == myself and not s.HasTalent(152107--[[Grimoire of Supremacy]])) then
		doomguard[destGUID] = {}
		doomguard[destGUID].summoned = ts
		doomguard[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Infernal" and sourceGUID == myself and not s.HasTalent(152107--[[Grimoire of Supremacy]])) then
		infernal[destGUID] = {}
		infernal[destGUID].summoned = ts
		infernal[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Felguard" and sourceGUID == myself and spellId == 111898--[[Grimoire: Felguard]]) then
		service[destGUID] = {}
		service[destGUID].summoned = ts
		service[destGUID].de = false
	end		
	if (event=="SPELL_SUMMON" and destName=="Imp" and sourceGUID == myself and spellId == 111859--[[Grimoire: Imp]]) then
		service[destGUID] = {}
		service[destGUID].summoned = ts
		service[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Voidwalker" and sourceGUID == myself and spellId == 111895--[[Grimoire: Voidwalker]]) then
		service[destGUID] = {}
		service[destGUID].summoned = ts
		service[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Succubus" and sourceGUID == myself and spellId == 111896--[[Grimoire: Succubus]]) then
		service[destGUID] = {}
		service[destGUID].summoned = ts
		service[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Felhunter" and sourceGUID == myself and spellId == 111897--[[Grimoire: Felhunter]]) then
		service[destGUID] = {}
		service[destGUID].summoned = ts
		service[destGUID].de = false
	end
	if (event=="SPELL_SUMMON" and destName=="Darkglare" and sourceGUID == myself and spellId == 205180--[[Summon Darkglare]]) then
		darkglare[destGUID] = {}
		darkglare[destGUID].summoned = ts
		darkglare[destGUID].de = false
	end
	
	if (sourceGUID == myself or sourceGUID == pet) and (destGUID ~= myself and destGUID ~= pet) and target_is_outsider and (string.find(event, "_DAMAGE") or string.find(event, "_MISSED")) then
		AoETargets[destGUID] = CurrentTimestamp
	end
--	if sourceGUID ~= myself and destGUID == myself and source_is_outsider and (string.find(event, "_DAMAGE") or string.find(event, "_MISSED")) then
--		AoETargets[sourceGUID] = CurrentTimestamp
--	end
	if event == "UNIT_DIED" or event == "UNIT_DESTROYED" or event == "UNIT_DISSIPATES" then
		AoETargets[destGUID] = nil
		dreadstalkers[destGUID] = nil
		doomguard[destGUID] = nil
		infernal[destGUID] = nil
		service[destGUID] = nil
		darkglare[destGUID] = nil
		wildimps[destGUID] = nil
	end

	-- Imps die from Implosion:
	if event == "SPELL_INSTAKILL" and destName == "Wild Imp" and sourceGUID == myself then
		wildimps[destGUID] = nil
	end

	-- Imps die after casting 10 times:
	if event == "SPELL_CAST_SUCCESS" and sourceName == "Wild Imp" then
		for key, value in pairs(wildimps) do
			if sourceGUID == key then
				wildimps[key].casts = wildimps[key].casts + 1
				if wildimps[key].casts >= 10 then
					wildimps[key] = nil
				end
			end
		end
	end

end

-- Check if we are in AoE mode
function a.ActiveEnemies()
	local now = time()
	local i = 0
	foreach(AoETargets, function(k, v)
		if v and now - v > 3 then
			AoETargets[k] = nil
		else
			i = i + 1
		end
	end)
	return i
end

a.leaveCombat = function()
	x.CombatStart = 0
end

a.enterCombat = function()
	x.CombatStart = GetTime()
end


a.UNIT_SPELLCAST_SUCCEEDED = function (event, ...)
	unit, spellName = ...
	local ts = GetTime()
	if unit == "player" then
		_, _, _, _, _, _, spellId = GetSpellInfo(spellName)
		if spellId then
			x.LastCastSpell = spellId
			x.LastCastTime = GetTime()
		end

		-- we probably do not need this...
--		if spellId == 196277--[[Implosion]] then
--			foreach(wildimps, function(k, v)
--				wildimps[k] = nil
--			end)
--		end

		if spellId == 193396--[[Demonic Empowerment]] then
			foreach(dreadstalkers, function(k, v)
				if ts - v.summoned >= 12 then
					dreadstalkers[k] = nil
				else
					dreadstalkers[k].de = true
				end
			end)
			foreach(wildimps, function(k, v)
				if ts - v.summoned >= 12 then
					wildimps[k] = nil
				else
					wildimps[k].de = true
				end
			end)
			foreach(doomguard, function(k, v)
				if ts - v.summoned >= 12 then
					doomguard[k] = nil
				else
					doomguard[k].de = true
				end
			end)
			foreach(infernal, function(k, v)
				if ts - v.summoned >= 12 then
					infernal[k] = nil
				else
					infernal[k].de = true
				end
			end)
			foreach(service, function(k, v)
				if ts - v.summoned >= 12 then
					service[k] = nil
				else
					service[k].de = true
				end
			end)
			foreach(darkglare, function(k, v)
				if ts - v.summoned >= 12 then
					darkglare[k] = nil
				else
					darkglare[k].de = true
				end
			end)
		end
	end
end

-- register events
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_ENABLED", a.leaveCombat)
s.RegisterModuleEvent(AddonName, "PLAYER_REGEN_DISABLED", a.enterCombat)
s.RegisterModuleEvent(AddonName, "COMBAT_LOG_EVENT_UNFILTERED", a.COMBAT_LOG_EVENT_UNFILTERED)
s.RegisterModuleEvent(AddonName, "UNIT_SPELLCAST_SUCCEEDED", a.UNIT_SPELLCAST_SUCCEEDED)
